# Class Oid

java.lang.Object
org.ietf.jgss.Oid

public class Oid extends Object
This class represents Universal Object Identifiers (Oids) and their associated operations.

Oids are hierarchically globally-interpretable identifiers used within the GSS-API framework to identify mechanisms and name formats.

The structure and encoding of Oids is defined in ISOIEC-8824 and ISOIEC-8825. For example the Oid representation of Kerberos V5 mechanism is "1.2.840.113554.1.2.2"

The GSSName name class contains public static Oid objects representing the standard name types defined in GSS-API.

Since:
  1.4

## Constructor Summary

Constructors
Constructor
Description
`Oid(byte[] data)`
Creates an Oid object from its ASN.1 DER encoding.
`Oid(InputStream derOid)`
Creates an Oid object from its ASN.1 DER encoding.
`Oid(String strOid)`
Constructs an Oid object from a string representation of its integer components.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`containedIn(Oid[] oids)`
A utility method to test if this Oid value is contained within the supplied Oid array.
`boolean`
`equals(Object other)`
Tests if two Oid objects represent the same Object identifier value.
`byte[]`
`getDER()`
Returns the full ASN.1 DER encoding for this oid object, which includes the tag and length.
`int`
`hashCode()`
Returns a hashcode value for this Oid.
`String`
`toString()`
Returns a string representation of the oid's integer components in dot separated notation.

### Methods declared in class Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### Oid

public Oid(String strOid) throws GSSException
Constructs an Oid object from a string representation of its integer components.

Parameters:
  `strOid` - the dot separated string representation of the oid. For instance, "1.2.840.113554.1.2.2".
Throws:
  `GSSException` - may be thrown when the string is incorrectly formatted

### Oid

public Oid(InputStream derOid) throws GSSException
Creates an Oid object from its ASN.1 DER encoding. This refers to the full encoding including tag and length. The structure and encoding of Oids is defined in ISOIEC-8824 and ISOIEC-8825. This method is identical in functionality to its byte array counterpart.

Parameters:
  `derOid` - stream containing the DER encoded oid
Throws:
  `GSSException` - may be thrown when the DER encoding does not follow the prescribed format.

### Oid

public Oid(byte[] data) throws GSSException
Creates an Oid object from its ASN.1 DER encoding. This refers to the full encoding including tag and length. The structure and encoding of Oids is defined in ISOIEC-8824 and ISOIEC-8825. This method is identical in functionality to its InputStream counterpart.

Parameters:
  `data` - byte array containing the DER encoded oid
Throws:
  `GSSException` - may be thrown when the DER encoding does not follow the prescribed format.

## Method Details

### toString

public String toString()
Returns a string representation of the oid's integer components in dot separated notation.

Overrides:
  `toString` in class `Object`
Returns:
  string representation in the following format: "1.2.3.4.5"

### equals

public boolean equals(Object other)
Tests if two Oid objects represent the same Object identifier value.

Overrides:
  `equals` in class `Object`
Parameters:
  `other` - the Oid object that has to be compared to this one
Returns:
  `true` if the two Oid objects represent the same value, `false` otherwise.
See Also:
  - `Object.hashCode()`
  - `HashMap`

### getDER

public byte[] getDER() throws GSSException
Returns the full ASN.1 DER encoding for this oid object, which includes the tag and length.

Returns:
  byte array containing the DER encoding of this oid object.
Throws:
  `GSSException` - may be thrown when the oid can't be encoded

### containedIn

public boolean containedIn(Oid[] oids)
A utility method to test if this Oid value is contained within the supplied Oid array.

Parameters:
  `oids` - the array of Oid's to search
Returns:
  true if the array contains this Oid value, false otherwise

### hashCode

public int hashCode()
Returns a hashcode value for this Oid.

Overrides:
  `hashCode` in class `Object`
Returns:
  a hashcode value for this Oid
See Also:
  - `Object.equals(java.lang.Object)`
  - `System.identityHashCode(Object)`